--AHHH EXODIA IT'S NOT POSSIBLE
--by minenice

--rendition of the cutscene heavily inspired by
-- https://youtu.be/gbuwZORI2Rg

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

local exodiaTimer = 0
local exodiaUser = nil

local greedDrawInterval = TICRATE/3
local seqTime = 6*TICRATE + 3*TICRATE/5

local init_overlay = false

freeslot(
	"sfx_seqexd",
	"sfx_exdsfx",
	"sfx_exdhit",
	"sfx_exduse"
)

--thanks call
local function generateHFForPlayer(p)
    if p and p.valid and p.mo and p.mo.valid then
        return {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
    else
        return {{}, {}}
    end
end

local function resetExodiaData(p)
	p.exodiaData = {
		exodiaCooldown = 0,
		exodiaUseTimer = 0,
		exodiaParts = 0,
		frozenStoredData = {
			x = 0, y = 0, z = 0,
			momx = 0, momy = 0, momz = 0,
			invtime = 0, growtime = 0, rockettime = 0, hyutime = 0, egg = 0
		}
	}
end

local function summonExodia(p)
	exodiaTimer = 1
	exodiaUser = p
	p.exodiaData.exodiaParts = 0
end

local function greedOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	if (p.exodiaData and p.exodiaData.exodiaCooldown ~= 0) or (exodiaTimer ~= 0) then
		return 0
	end
	--don't give exodia if someone already finished
	for po in players.iterate do
		if po.exiting and (not po.spectator) then return 0 end
	end
	if (p.exodiaData and p.exodiaData.exodiaParts ~= 0) then
		return newodds * min(p.exodiaData.exodiaParts, 3)
	end
	return newodds
end

local function getGreed(p, i)
	if p.exodiaData then
		p.exodiaData.exodiaCooldown = 18*TICRATE
	end
end

local function useGreed(p, cmd)
	local mo = p.mo
	local kartstuff = p.kartstuff
	
	kartstuff[k_itemamount] = $-1
	
	if p.exodiaData then
		p.exodiaData.exodiaUseTimer = 20
		if p.mo and p.exodiaData.exodiaParts >= 4 then
			K_PlayPowerGloatSound(p.mo)
			if fesScoring then
				FES_scoring_rewardPlayerAction(p, "xitem_exodia")
			end
		end
	end
end

local function setupFrozenData(p)
	local pdat = p.exodiaData
	local fdat = pdat.frozenStoredData
	local pmo = p.mo
	local pks = p.kartstuff
	if pmo then
		fdat.momx, fdat.momy = pmo.momx, pmo.momy
	else
		fdat.momx, fdat.momy = 0, 0
	end
	fdat.invtime = pks[k_invincibilitytimer]
	fdat.growtime = pks[k_growshrinktimer]
	fdat.rockettime = pks[k_rocketsneakertimer]
	fdat.hyutime = pks[k_hyudorotimer]
	fdat.egg = pks[k_eggmanexplode]
end

local function handleExodiaStuff(p)	
	if not p.exodiaData then
		resetExodiaData(p)
	end
	
	local pdat = p.exodiaData
	local pmo = p.mo
	local pks = p.kartstuff
	
	if pdat.exodiaUseTimer > 0 then
		if (pdat.exodiaUseTimer % 10) == 0 then
			if pdat.exodiaParts >= 5 then
				summonExodia(p)
			else
				S_StartSound(nil, sfx_exduse, p)
				pdat.exodiaParts = $+1
			end
		end
		pdat.exodiaUseTimer = $ - 1
	end
	if pdat.exodiaCooldown > 0 then
		pdat.exodiaCooldown = $ - 1
	end
end

local function handleExodiaSeq()
	if exodiaTimer > 0 then
		local pBlame = exodiaUser and exodiaUser or nil
		if exodiaTimer == 1 then
			S_ChangeMusic("SEQEXD")
			S_StartSound(nil, sfx_seqexd)
			for p in players.iterate do
				setupFrozenData(p)
			end
		elseif exodiaTimer == 81 then
			S_StartSound(nil, sfx_exdsfx)
		elseif exodiaTimer == 117 then
			S_StartSound(nil, sfx_exdsfx)
		elseif exodiaTimer == 166 then
			S_StartSound(nil, sfx_exdhit)
			for p in players.iterate do
				--wario fucking dies 2
				if p == pBlame then continue end 
				if pBlame and (p.kartTeam ~= nil and pBlame.kartTeam ~= nil) and p.kartTeam == pBlame.kartTeam then continue end
				if p.mo and p.mo.skin == "mk64wario" and sfx_k64wsp and (not S_SoundPlaying(p.mo, sfx_k64wsp)) then
					S_StartSound(p.mo, sfx_k64wsp)
				end
			end
		end
		for p in players.iterate do
			if not p.mo then continue end
			if not p.exodiaData then 
				resetExodiaData(p)
				setupFrozenData(p)
			end
			local pdat = p.exodiaData
			local fdat = pdat.frozenStoredData
			local pmo = p.mo
			local pks = p.kartstuff
			
			pks[k_invincibilitytimer] = fdat.invtime
			pks[k_growshrinktimer] = fdat.growtime
			pks[k_rocketsneakertimer] = fdat.rockettime
			pks[k_hyudorotimer] = fdat.hyutime
			pks[k_eggmanexplode] = fdat.egg
			
			if pmo and pmo.valid and P_IsObjectOnGround(pmo) then
				if pmo.momx or pmo.momy then
					fdat.momx, fdat.momy = pmo.momx, pmo.momy
				end
				pks[k_squishedtimer] = 2
			end
		end
		exodiaTimer = $+1
		if exodiaTimer == seqTime+1 then
			exodiaTimer = -1
			local maxPlace = pBlame and pBlame.kartstuff[k_position] or 2
			for p in players.iterate do
				if not p.mo then continue end
				if not p.exodiaData then 
					resetExodiaData(p)
					setupFrozenData(p)
				end
				local pdat = p.exodiaData
				local fdat = pdat.frozenStoredData
				local pmo = p.mo
				local pks = p.kartstuff
				
				pdat.exodiaParts = 0
				P_RestoreMusic(p)
				P_FlashPal(p, 1, 4)
				pks[k_squishedtimer] = 0
				p.powers[pw_flashing] = 0
				
				local pos = pks[k_position]
				local blameMo = pBlame and pBlame.mo or nil
				if p ~= pBlame and pks[k_position] < maxPlace then
					--don't hit teammates
					if pBlame and (p.kartTeam ~= nil and pBlame.kartTeam ~= nil) and p.kartTeam == pBlame.kartTeam then continue end
					if pos == 1 then
						K_ExplodePlayer(p, blameMo, blameMo)
						pks[k_spinouttimer] = ((5*$)/2)+1
						pmo.momz = $*2
					elseif pos > maxPlace/2 then
						K_SpinPlayer(p, blameMo, 1, blameMo, false)
					else
						K_ExplodePlayer(p, blameMo, blameMo)
					end
					
					if (hitfeed) then
						local source = generateHFForPlayer(pBlame)
						local victim = generateHFForPlayer(p)
						HF_SendHitMessage(source, victim, "H_XIEXDA")
					end
				end
				pmo.momx, pmo.momy = fdat.momx, fdat.momy
			end
		end
	end
end

local BASEVIDWIDTH  = 320
local BASEVIDHEIGHT = 200

local function cardHud(v, p, c)
	if not p then return end
	if not p.exodiaData then return end
	
	local fx, fy, fflags = xItemLib.func.hudFindFlags(v, p, c)
	local cardPatch = {v.cachePatch("EXDCARD1"), v.cachePatch("EXDCARD2")}
	local pdat = p.exodiaData
	
	for i = 1, pdat.exodiaParts do
		--v.drawScaled(fx + FRACUNIT*7*(i-1), fy*FRACUNIT, scale, (i == 5) and cardPatch[2] or cardPatch[1], V_HUDTRANS|V_NOSCALESTART|V_OFFSET|fflags)
		if splitscreen < 2 then
			local scale = 3*FRACUNIT/4
			if i == pdat.exodiaParts then
				scale = TableLerp.outCubic(pdat.exodiaUseTimer % 10, 9, 3*FRACUNIT/4, FRACUNIT)
			end
			local dx = fx + 4
			local dy = fy - 4
			
			v.drawScaled((dx + 7*(i-1))*FRACUNIT, dy*FRACUNIT, scale, (i == 5) and cardPatch[2] or cardPatch[1], V_HUDTRANS|fflags)
		else
			local scale = FRACUNIT/2
			if i == pdat.exodiaParts then
				scale = TableLerp.outCubic(pdat.exodiaUseTimer % 10, 9, FRACUNIT/2, 3*FRACUNIT/5)
			end
			local dx = fx + 13
			local dy = fy + 4
			
			if c.pnum == 1 or c.pnum == 3 then -- If we are P1 or P3...	
				v.drawScaled((dx + 4*(i-1))*FRACUNIT, dy*FRACUNIT, scale, (i == 5) and cardPatch[2] or cardPatch[1], V_HUDTRANS|fflags)
			else -- else, that means we're P2 or P4.
				v.drawScaled((dx + 15 - 4*(i-1))*FRACUNIT, dy*FRACUNIT, scale, (i == 5) and cardPatch[2] or cardPatch[1], V_HUDTRANS|fflags)
			end
		end
	end
end
hud.add(cardHud, "game")

local function exodiaOverlay(v, p, c, t)
	local sx, sfx = v.dupx()
	local sy, sfy = v.dupy()
	local dupadjustx = (v.width()/sx)
	local duptweakx = (dupadjustx - BASEVIDWIDTH)/2

	local dupadjusty = (v.height()/sy)
	local duptweaky = (dupadjusty - BASEVIDHEIGHT)/2
	
	local largestScale = FRACUNIT
	if dupadjusty > dupadjustx then
		largestScale = FixedDiv(dupadjusty, 200)
	else
		largestScale = FixedDiv(dupadjustx, 300)
	end
	
	local seqBG = {
		v.cachePatch("SEQEXD1"),
		v.cachePatch("SEQEXD2"),
		v.cachePatch("SEQEXD3"),
		v.cachePatch("SEQEXD4"),
		v.cachePatch("SEQEXD5"),
		v.cachePatch("SEQEXD6"),
		v.cachePatch("SEQEXD7"),
		v.cachePatch("SEQEXD8"),
	}
	local seqSPR = {
		v.cachePatch("SEQEXD9"),
		v.cachePatch("SEQEXD10"),
		v.cachePatch("SEQEXD11"),
		v.cachePatch("SEQEXD12"),
	}
	local seqMark = {
		TICRATE*2,
		TICRATE*3,
		TICRATE*4,
		186,
		seqTime+1
	}
	
	--blank out the "canvas"
	v.drawFill(-duptweakx, -duptweaky, dupadjustx+duptweakx, dupadjusty+duptweaky, 120)
	local x = 0
	local y = 0
	
	--face
	if t <= seqMark[1] then
		x = TableLerp.outCubic(t, seqMark[1], 0, -24*FRACUNIT)
		y = TableLerp.outCubic(t, seqMark[1], 3*FRACUNIT, -2*FRACUNIT)
		v.drawScaled(x, y, largestScale, seqBG[1], V_SNAPTOTOP|V_SNAPTOLEFT)
		if t <= TICRATE then
			v.fadeScreen(120, TableLerp.flerp(t, TICRATE, 10, 0))
		end
	
	--left hand
	elseif t <= seqMark[2] then
		y = -10 * largestScale
		local sprx = 0
		local spry = 20*FRACUNIT
		
		v.drawScaled(x, y, largestScale, seqBG[2], V_SNAPTOTOP|V_SNAPTOLEFT)
		if t-seqMark[1]-TICRATE/4 >= 0 and t-seqMark[1] < TICRATE/2 then
			sprx = TableLerp.inQuad(t-seqMark[1]-TICRATE/4, TICRATE/4, -330*FRACUNIT, 1*FRACUNIT)
			spry = TableLerp.inQuad(t-seqMark[1]-TICRATE/4, TICRATE/4, 120*FRACUNIT, 20*FRACUNIT)
			v.drawScaled(sprx, spry, largestScale, seqSPR[1], V_SNAPTOTOP|V_SNAPTOLEFT)
		elseif t-seqMark[1] >= TICRATE/2 then
			v.drawScaled(sprx, spry, largestScale, seqSPR[2], V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	
	--right hand
	elseif t <= seqMark[3] then
		y = -10 * largestScale
		local sprx = (dupadjustx-duptweakx-256)*FRACUNIT
		local spry = 20*FRACUNIT
		
		v.drawScaled(x, y, largestScale, seqBG[3], V_SNAPTOTOP|V_SNAPTOLEFT)
		if t-seqMark[2]-TICRATE/4 >= 0 and t-seqMark[2] < TICRATE/2 then
			sprx = TableLerp.inQuad(t-seqMark[2]-TICRATE/4, TICRATE/4, 330*FRACUNIT, (dupadjustx-duptweakx-256-1)*FRACUNIT)
			spry = TableLerp.inQuad(t-seqMark[2]-TICRATE/4, TICRATE/4, 120*FRACUNIT, 20*FRACUNIT)
			v.drawScaled(sprx, spry, largestScale, seqSPR[3], V_SNAPTOTOP|V_SNAPTOLEFT)
		elseif t-seqMark[2] >= TICRATE/2 then
			v.drawScaled(sprx, spry, largestScale, seqSPR[4], V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	
	--charge
	elseif t <= seqMark[4] then
		y = -10 * largestScale
		
		if t < 182 then
			v.drawScaled(x, y, largestScale, seqBG[4], V_SNAPTOTOP|V_SNAPTOLEFT)
		elseif t < 182+3 then
			v.drawScaled(x, y, largestScale, seqBG[5], V_SNAPTOTOP|V_SNAPTOLEFT)
		else
			v.drawScaled(x, y, largestScale, seqBG[6], V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		
		if t >= seqMark[3] and t-seqMark[3] <= TICRATE/3 then
			v.fadeScreen(120, TableLerp.inQuad(t-seqMark[3], TICRATE/3, 0, 10))
		elseif t >= (seqMark[3]+TICRATE/3) and t-(seqMark[3]+TICRATE/3) <= 2*TICRATE/3 then
			v.fadeScreen(120, TableLerp.flerp(t-(seqMark[3]+TICRATE/3), 2*TICRATE/3, 10, 0))
		end
	
	--fire
	elseif t <= seqMark[5] then
		y = -10 * largestScale
		if t-seqMark[4] >= 0 then
			x = TableLerp.flerp(t-seqMark[4], seqMark[5]-seqMark[4], 0, -10*FRACUNIT)
		end
		if t >= seqMark[4] + 2*TICRATE/4 then
			y = $ + ((t/2)%2)*largestScale
		end
		
		if t-seqMark[4] >= 0 and t-seqMark[4] <= TICRATE/4 then
			v.drawScaled(x, y, largestScale, seqBG[8], V_SNAPTOTOP|V_SNAPTOLEFT)
		elseif t-seqMark[4] >= 0 and t-seqMark[4]-TICRATE/4 <= TICRATE/4 then
			v.drawScaled(x, y, largestScale, seqBG[7], V_SNAPTOTOP|V_SNAPTOLEFT)
		else
			v.drawScaled(x, y, largestScale, seqBG[7 + ((t/2)%2)], V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		
		if t-seqMark[4] >= 0 and t-seqMark[4] <= TICRATE then
			v.fadeScreen(120, TableLerp.flerp(t-seqMark[4], TICRATE, 10, 0))
		elseif t-seqMark[5]+TICRATE/2 >= 0 and t-seqMark[5]+TICRATE/2 <= TICRATE/2 then
			v.fadeScreen(120, TableLerp.flerp(t-seqMark[5]+TICRATE/2, TICRATE/2, 0, 10))
		end
		
	end
	--bars
	v.drawFill(-duptweakx, -duptweaky, dupadjustx+duptweakx, 10, 31|V_SNAPTOTOP|V_SNAPTOLEFT)
	v.drawFill(-duptweakx, (dupadjusty+duptweaky)-10, dupadjustx+duptweakx, 10, 31|V_SNAPTOTOP|V_SNAPTOLEFT)
	
	x = nil
	y = nil
end

addHook("ThinkFrame", function()
	if leveltime == 0 then
		for p in players.iterate do
			resetExodiaData(p)
		end
		exodiaTimer = 0
		exodiaUser = nil
	end
	for p in players.iterate do
		handleExodiaStuff(p)
	end
	handleExodiaSeq()
	if not init_overlay then
		hud.add(function(v, p, c)
			if exodiaTimer > 0 then
				exodiaOverlay(v, p, c, exodiaTimer)
			end
		end, "game")
		init_overlay = true
	end
end)

if fesScoring then
	FES_scoring_addAction("xitem_exodia", "AAAGH! EXODIA!", 100)
end

if xItemLib then
	xItemLib.func.addItem{"XITEM_SAMPLER_EXODIA", 
		"Pot Of Greed", 
		"K_ITEXDA", 
		"K_ISEXDA", 
		XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_UNIQUE, 
		{0, 0, 0, 0, 1, 2, 3, 3, 1, 0}, 
		{0, 1}, 
		getGreed, 
		useGreed, 
		false, 
		greedOdds, 
		false, 
		{0, {SPR_XITS, 5}}, 
		true, 
		nil, 
		nil
	}
	
	xItemLib.func.setXItemModData("XITEM_DESCRIPTIONS", "XITEM_SAMPLER_EXODIA", {
		tipDescription1 = "Get 2 pieces of Exodia the Forbidden One",
		tipDescription2 = "Summon Exodia when 5 are obtained",
		tipUsage1 = "This item is unique and appears very rarely",
		tipUsage2 = "Damage done to opponents increases the further ahead they are",
	})
end

addHook("NetVars", function(net)
	exodiaTimer = net(exodiaTimer)
	exodiaUser = net(exodiaUser)
end)
